<?php

namespace Drupal\otp_verification;

/**
 * @file
 * This class represents support information for customer.
 */

use \Drupal\otp_verification\MiniorangeOtpUtilities;
use \Drupal\otp_verification\MiniorangeOTPVerificationCustomer;

/**
 * @file
 * Contains miniOrange Support class.
 */
class MiniorangeOTPVerificationSupport
{
  public $email;
  public $phone;
  public $query;

  public function __construct($email, $phone, $query)
  {
    $this->email = $email;
    $this->phone = $phone;
    $this->query = $query;
  }

  /**
   * Send support query.
   */
  public function sendSupportQuery()
  {
    $this->query = '[Drupal 8 OTP Verification Module] ' . $this->query;
    $fields = array(
      'company' => $_SERVER['SERVER_NAME'],
      'email' => $this->email,
      'ccEmail' => 'drupalsupport@xecurify.com',
      'phone' => $this->phone,
      'query' => $this->query,
    );
    $url = MiniorangeOTPVerificationConstants::BASE_URL . '/moas/rest/customer/contact-us';

    $mo_otp_verification_customer = new MiniorangeOTPVerificationCustomer(null,null,null,null);
    if (!MiniorangeOtpUtilities::isCurlInstalled()) {
      return json_encode(array(
        "statusCode" => 'ERROR',
        "statusMessage" => 'cURL is not enabled on your site. Please enable the cURL module.',
      ));
    }
    $fieldString = is_string($fields)?$fields:json_encode($fields);

    $header = $mo_otp_verification_customer->getHeader(true);

    try{
      $response = \Drupal::httpClient()
        ->post($url, [
          'body' => $fieldString,
          'allow_redirects' => TRUE,
          'http_errors' => FALSE,
          'decode_content'  => true,
          'verify' => FALSE,
          'headers' =>$header
        ]);
      return true;
    }
    catch (RequestException $exception)
    {
      return false;
    }
  }
}
